﻿Public Class Card
    Private Shared idCounter As Integer = 1
    Private id As Integer
    Private boxId As PictureBox
    Private cardImage As Image
    Private cardName As Tuple(Of String, String)
    Private cardSuit As String
    Private cardNumber as String
    Private cardLocation As Point
    Private cardHidden As Boolean

    Public Sub New(name As Tuple(Of String, String), Optional hidden As Boolean = False)
        id = idCounter
        idCounter += 1
        boxId = New PictureBox()
        cardName = name
        cardSuit = name.item1
        cardNumber = name.item2
        cardHidden = hidden
        cardImage = Utilities.GetCardImage(name, hidden)
    End Sub

    Public Sub SetLocation(location As point)
        cardLocation = location
    End Sub

    Public Sub SetName(name As Tuple(Of String, String))
        cardName = name
    End Sub

    Public Sub SetHidden(hidden As Boolean)
        cardHidden = hidden
    End Sub

    Public Function GetId()
        Return id
    End Function

    Public Function GetBoxId()
        Return boxId
    End Function

    Public Function GetName()
        Return cardName
    End Function

    Public Function GetSuit() As String
        Return cardSuit
    End Function

    Public Function GetNumber() As String
        Return cardNumber
    End Function
    Public Function GetLocation()
        Return cardLocation
    End Function

    Public Function IsHidden()
        Return cardHidden
    End Function
End Class