﻿Public Class GameWindow
    Private WithEvents game As Game

    Private Sub StartGame_Click(sender As Object, e As EventArgs) Handles StartGame.Click
        game = New Game()
        game.Start()
    End Sub

    Private Sub HitButton_Click(sender As Object, e As EventArgs) Handles HitButton.Click
        game.Hit()
    End Sub

    Private Sub StandButton_Click(sender As Object, e As EventArgs) Handles StandButton.Click
        game.Stand()
    End Sub

    Private Sub OnResetUI() Handles game.ResetUI
        Dim pictureBoxes() As PictureBox =
                {PlayerCard1, PlayerCard2, PlayerCard3, PlayerCard4, PlayerCard5, PlayerCard6, PlayerCard7, PlayerCard8,
                 PlayerCard9, PlayerCard10}
        For Each box In pictureBoxes
            box.Image = Nothing
        Next
        WinMessage.ResetText()
        HitButton.Enabled = True
        StandButton.Enabled = True
        StartGame.Enabled = False
    End Sub

    Private Sub OnCardDealt(card As Card, cardNumber As String, hide As Boolean) _
        Handles game.CardDealt
        Dim pictureBox As PictureBox
        pictureBox = CType(Me.Controls.Find("PlayerCard" + cardNumber, True).First(), PictureBox)
        If hide Then
            pictureBox.Image = My.Resources.blue
        Else
            pictureBox.Image = Utilities.GetCardImage(Tuple.create(card.GetSuit(), card.GetNumber()))
        End If
    End Sub

    Private Sub SetTotalLabels(playerTotalAmount, dealerTotalAmount) Handles game.SetTotalLabels
        Dim dealerLabelTotal As String = DealerTotal.Text.Split(": ")(0)
        Dim playerLabelTotal As String = PlayerTotal.Text.Split(": ")(0)
        DealerTotal.Text = dealerLabelTotal + ": " + dealerTotalAmount.ToString()
        PlayerTotal.Text = playerLabelTotal + ": " + playerTotalAmount.ToString()
    End Sub

    Private Sub ShowDealerCard(card) Handles game.ShowDealerCard
        PlayerCard7.Image = Utilities.GetCardImage(card)
    End Sub

    Private Sub EndPlayerTurn() Handles game.EndPlayerTurn
        HitButton.Enabled = False
        StandButton.Enabled = False
    End Sub

    Private Sub MessageLabel(message) Handles game.MessageLabel
        WinMessage.Text = message
    End Sub

    Private Sub EndGame(message) Handles game.EndGame
        WinMessage.Text = message
        HitButton.Enabled = False
        StandButton.Enabled = False
        StartGame.Enabled = True
    End Sub
End Class
